diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/wifi-ack-policy-selector.cc ns-3.31/src/wifi/model/wifi-ack-policy-selector.cc
--- ns-3.30.1/src/wifi/model/wifi-ack-policy-selector.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/wifi/model/wifi-ack-policy-selector.cc	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,87 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2019 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#include "ns3/log.h"
+#include "wifi-ack-policy-selector.h"
+#include <set>
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("WifiAckPolicySelector");
+
+NS_OBJECT_ENSURE_REGISTERED (WifiAckPolicySelector);
+
+TypeId
+WifiAckPolicySelector::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::WifiAckPolicySelector")
+    .SetParent<Object> ()
+    .SetGroupName("Wifi")
+  ;
+  return tid;
+}
+
+WifiAckPolicySelector::~WifiAckPolicySelector ()
+{
+  NS_LOG_FUNCTION (this);
+}
+
+void
+WifiAckPolicySelector::DoDispose ()
+{
+  NS_LOG_FUNCTION (this);
+  m_qosTxop = 0;
+}
+
+void
+WifiAckPolicySelector::SetQosTxop (Ptr<QosTxop> qosTxop)
+{
+  NS_LOG_FUNCTION (this << qosTxop);
+  m_qosTxop = qosTxop;
+}
+
+Ptr<QosTxop>
+WifiAckPolicySelector::GetQosTxop (void) const
+{
+  return m_qosTxop;
+}
+
+void
+WifiAckPolicySelector::SetAckPolicy (Ptr<WifiPsdu> psdu, const MacLowTransmissionParameters & params)
+{
+  NS_LOG_FUNCTION (psdu << params);
+
+  std::set<uint8_t> tids = psdu->GetTids ();
+  NS_ASSERT (tids.size () == 1);
+  uint8_t tid = *tids.begin ();
+
+  if (params.MustWaitNormalAck () || params.MustWaitBlockAck ())
+    {
+      // Normal Ack or Implicit Block Ack Request policy
+      psdu->SetAckPolicyForTid (tid, WifiMacHeader::NORMAL_ACK);
+    }
+  else
+    {
+      // Block Ack policy
+      psdu->SetAckPolicyForTid (tid, WifiMacHeader::BLOCK_ACK);
+    }
+}
+
+} //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/wifi-ack-policy-selector.h ns-3.31/src/wifi/model/wifi-ack-policy-selector.h
--- ns-3.30.1/src/wifi/model/wifi-ack-policy-selector.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/wifi/model/wifi-ack-policy-selector.h	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,93 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2019 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#ifndef WIFI_ACK_POLICY_SELECTOR_H
+#define WIFI_ACK_POLICY_SELECTOR_H
+
+#include "ns3/object.h"
+#include "mac-low-transmission-parameters.h"
+#include "qos-txop.h"
+#include "wifi-psdu.h"
+
+namespace ns3 {
+
+/**
+ * \ingroup wifi
+ *
+ * WifiAckPolicySelector is in charge of selecting the acknowledgment policy
+ * for PSDUs containing QoS Data frames.
+ */
+class WifiAckPolicySelector : public Object
+{
+public:
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+  virtual ~WifiAckPolicySelector();
+
+  virtual void DoDispose (void);
+
+  /**
+   * Set the QoS Txop associated with this ack policy selector.
+   *
+   * \param qosTxop the QoS Txop.
+   */
+  void SetQosTxop (Ptr<QosTxop> qosTxop);
+
+  /**
+   * Get the QoS Txop associated with this ack policy selector.
+   *
+   * \return the QoS Txop.
+   */
+  Ptr<QosTxop> GetQosTxop (void) const;
+
+  /**
+   * Set the QoS Ack Policy for the QoS Data frames contained in the given PSDU
+   * according to the given MacLow transmission parameters. Only single-TID A-MPDUs
+   * are supported at the moment, hence it is expected that all the QoS Data frames
+   * contained in the given PSDU have the same TID. This function is typically
+   * called by MacLow before forwarding the PSDU down to the PHY layer.
+   *
+   * \param psdu the given PSDU.
+   * \param params the given MacLow transmission parameters.
+   */
+  static void SetAckPolicy (Ptr<WifiPsdu> psdu, const MacLowTransmissionParameters & params);
+
+  /**
+   * Update the transmission parameters related to the acknowledgment policy for
+   * the given PSDU. This method is typically called by the MPDU aggregator when
+   * trying to aggregate another MPDU to the current A-MPDU. In fact, the
+   * AckPolicySelector may switch to a different acknowledgment policy when a
+   * new MPDU is aggregated to an A-MPDU.
+   *
+   * \param psdu the given PSDU.
+   * \param params the MacLow parameters to update.
+   */
+  virtual void UpdateTxParams (Ptr<WifiPsdu> psdu, MacLowTransmissionParameters & params) = 0;
+
+protected:
+  Ptr<QosTxop> m_qosTxop;      //!< the QoS Txop this selector is associated with
+};
+
+} //namespace ns3
+
+#endif /* WIFI_ACK_POLICY_SELECTOR_H */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/wifi-information-element.h ns-3.31/src/wifi/model/wifi-information-element.h
--- ns-3.30.1/src/wifi/model/wifi-information-element.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/wifi-information-element.h	2020-06-27 17:38:30.000000000 -0700
@@ -266,7 +266,7 @@
    * Get the size of the serialized IE including Element ID and
    * length fields.
    *
-   * \return the size of the serialized IE
+   * \return the size of the serialized IE in bytes
    */
   uint16_t GetSerializedSize () const;
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/wifi-information-element-vector.h ns-3.31/src/wifi/model/wifi-information-element-vector.h
--- ns-3.30.1/src/wifi/model/wifi-information-element-vector.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/wifi-information-element-vector.h	2020-06-27 17:38:30.000000000 -0700
@@ -127,8 +127,7 @@
    */
   uint32_t GetSize () const;
   IE_VECTOR m_elements; //!< Information element vector
-  /// Size in bytes (actually, max packet length)
-  uint16_t m_maxSize;
+  uint16_t m_maxSize;   //!< Size in bytes (actually, max packet length)
 };
 
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/wifi-mac.cc ns-3.31/src/wifi/model/wifi-mac.cc
--- ns-3.30.1/src/wifi/model/wifi-mac.cc	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wifi/model/wifi-mac.cc	2020-06-27 17:38:30.000000000 -0700
@@ -130,12 +130,7 @@
   static TypeId tid = TypeId ("ns3::WifiMac")
     .SetParent<Object> ()
     .SetGroupName ("Wifi")
-    .AddAttribute ("CtsTimeout", "When this timeout expires, the RTS/CTS handshake has failed.",
-                   TimeValue (GetDefaultCtsAckTimeout ()),
-                   MakeTimeAccessor (&WifiMac::SetCtsTimeout,
-                                     &WifiMac::GetCtsTimeout),
-                   MakeTimeChecker ())
-    .AddAttribute ("AckTimeout", "When this timeout expires, the DATA/ACK handshake has failed.",
+    .AddAttribute ("AckTimeout", "When this timeout expires, the Data/Ack handshake has failed.",
                    TimeValue (GetDefaultCtsAckTimeout ()),
                    MakeTimeAccessor (&WifiMac::GetAckTimeout,
                                      &WifiMac::SetAckTimeout),
@@ -321,7 +316,6 @@
   SetSlot (MicroSeconds (9));
   SetEifsNoDifs (MicroSeconds (16 + 44));
   SetPifs (MicroSeconds (16 + 9));
-  SetCtsTimeout (MicroSeconds (16 + 44 + 9 + GetDefaultMaxPropagationDelay ().GetMicroSeconds () * 2));
   SetAckTimeout (MicroSeconds (16 + 44 + 9 + GetDefaultMaxPropagationDelay ().GetMicroSeconds () * 2));
 }
 
@@ -333,7 +327,6 @@
   SetSlot (MicroSeconds (20));
   SetEifsNoDifs (MicroSeconds (10 + 304));
   SetPifs (MicroSeconds (10 + 20));
-  SetCtsTimeout (MicroSeconds (10 + 304 + 20 + GetDefaultMaxPropagationDelay ().GetMicroSeconds () * 2));
   SetAckTimeout (MicroSeconds (10 + 304 + 20 + GetDefaultMaxPropagationDelay ().GetMicroSeconds () * 2));
 }
 
@@ -349,7 +342,6 @@
   SetSlot (MicroSeconds (20));
   SetEifsNoDifs (MicroSeconds (10 + 304));
   SetPifs (MicroSeconds (10 + 20));
-  SetCtsTimeout (MicroSeconds (10 + 304 + 20 + GetDefaultMaxPropagationDelay ().GetMicroSeconds () * 2));
   SetAckTimeout (MicroSeconds (10 + 304 + 20 + GetDefaultMaxPropagationDelay ().GetMicroSeconds () * 2));
 }
 
@@ -361,7 +353,6 @@
   SetSlot (MicroSeconds (13));
   SetEifsNoDifs (MicroSeconds (32 + 88));
   SetPifs (MicroSeconds (32 + 13));
-  SetCtsTimeout (MicroSeconds (32 + 88 + 13 + GetDefaultMaxPropagationDelay ().GetMicroSeconds () * 2));
   SetAckTimeout (MicroSeconds (32 + 88 + 13 + GetDefaultMaxPropagationDelay ().GetMicroSeconds () * 2));
 }
 
@@ -373,7 +364,6 @@
   SetSlot (MicroSeconds (21));
   SetEifsNoDifs (MicroSeconds (64 + 176));
   SetPifs (MicroSeconds (64 + 21));
-  SetCtsTimeout (MicroSeconds (64 + 176 + 21 + GetDefaultMaxPropagationDelay ().GetMicroSeconds () * 2));
   SetAckTimeout (MicroSeconds (64 + 176 + 21 + GetDefaultMaxPropagationDelay ().GetMicroSeconds () * 2));
 }
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/wifi-mac.h ns-3.31/src/wifi/model/wifi-mac.h
--- ns-3.30.1/src/wifi/model/wifi-mac.h	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wifi/model/wifi-mac.h	2020-06-27 17:38:30.000000000 -0700
@@ -72,7 +72,7 @@
    */
   virtual void SetSlot (Time slotTime) = 0;
   /**
-   * \param sifs the sifs duration
+   * \param sifs the SIFS duration
    */
   virtual void SetSifs (Time sifs) = 0;
   /**
@@ -83,19 +83,15 @@
    */
   virtual void SetEifsNoDifs (Time eifsNoDifs) = 0;
   /**
-   * \param pifs the pifs duration.
+   * \param pifs the PIFS duration.
    */
   virtual void SetPifs (Time pifs) = 0;
   /**
-   * \param rifs the rifs duration.
+   * \param rifs the RIFS duration.
    */
   virtual void SetRifs (Time rifs) = 0;
   /**
-   * \param ctsTimeout the duration of a CTS timeout.
-   */
-  virtual void SetCtsTimeout (Time ctsTimeout) = 0;
-  /**
-   * \param ackTimeout the duration of an ACK timeout.
+   * \param ackTimeout the duration of an Ack timeout.
    */
   virtual void SetAckTimeout (Time ackTimeout) = 0;
   /**
@@ -105,10 +101,12 @@
    */
   void SetMaxPropagationDelay (Time delay);
   /**
-   * \param ssid the current ssid of this MAC layer.
+   * \param ssid the current SSID of this MAC layer.
    */
   virtual void SetSsid (Ssid ssid) = 0;
   /**
+   * Enable or disable short slot time feature.
+   *
    * \param enable true if short slot time is to be supported,
    *               false otherwise
    */
@@ -143,11 +141,7 @@
    */
   virtual Time GetEifsNoDifs (void) const = 0;
   /**
-   * \return the current CTS timeout duration.
-   */
-  virtual Time GetCtsTimeout (void) const = 0;
-  /**
-   * \return the current ACK timeout duration.
+   * \return the current Ack timeout duration.
    */
   virtual Time GetAckTimeout (void) const = 0;
   /**
@@ -155,7 +149,7 @@
    */
   virtual Mac48Address GetAddress (void) const = 0;
   /**
-   * \return the ssid which this MAC layer is going to try to stay in.
+   * \return the SSID which this MAC layer is going to try to stay in.
    */
   virtual Ssid GetSsid (void) const = 0;
   /**
@@ -163,7 +157,7 @@
    */
   virtual void SetAddress (Mac48Address address) = 0;
   /**
-   * \return the bssid of the network this device belongs to.
+   * \return the BSSID of the network this device belongs to.
    */
   virtual Mac48Address GetBssid (void) const = 0;
   /**
@@ -176,22 +170,22 @@
    * \param to the address to which the packet should be sent.
    * \param from the address from which the packet should be sent.
    *
-   * The packet should be enqueued in a tx queue, and should be
+   * The packet should be enqueued in a TX queue, and should be
    * dequeued as soon as the DCF function determines that
    * access it granted to this MAC. The extra parameter "from" allows
    * this device to operate in a bridged mode, forwarding received
    * frames without altering the source address.
    */
-  virtual void Enqueue (Ptr<const Packet> packet, Mac48Address to, Mac48Address from) = 0;
+  virtual void Enqueue (Ptr<Packet> packet, Mac48Address to, Mac48Address from) = 0;
   /**
    * \param packet the packet to send.
    * \param to the address to which the packet should be sent.
    *
-   * The packet should be enqueued in a tx queue, and should be
+   * The packet should be enqueued in a TX queue, and should be
    * dequeued as soon as the DCF function determines that
    * access it granted to this MAC.
    */
-  virtual void Enqueue (Ptr<const Packet> packet, Mac48Address to) = 0;
+  virtual void Enqueue (Ptr<Packet> packet, Mac48Address to) = 0;
   /**
    * \return if this MAC supports sending from arbitrary address.
    *
@@ -205,11 +199,11 @@
    */
   virtual void SetWifiPhy (Ptr<WifiPhy> phy) = 0;
   /**
-   * \return currently attached WifiPhy device
+   * \return the physical layer attached to this MAC
    */
   virtual Ptr<WifiPhy> GetWifiPhy (void) const = 0;
   /**
-   * remove currently attached WifiPhy device from this MAC.
+   * Remove currently attached WifiPhy device from this MAC.
    */
   virtual void ResetWifiPhy (void) = 0;
   /**
@@ -222,9 +216,10 @@
   virtual Ptr<WifiRemoteStationManager> GetWifiRemoteStationManager (void) const = 0;
 
   /**
-   * \param upCallback the callback to invoke when a packet must be forwarded up the stack.
+   * \param upCallback the callback to invoke when a packet must be
+   *        forwarded up the stack.
    */
-  virtual void SetForwardUpCallback (Callback<void,Ptr<Packet>, Mac48Address, Mac48Address> upCallback) = 0;
+  virtual void SetForwardUpCallback (Callback<void, Ptr<const Packet>, Mac48Address, Mac48Address> upCallback) = 0;
   /**
    * \param linkUp the callback to invoke when the link becomes up.
    */
@@ -233,28 +228,28 @@
    * \param linkDown the callback to invoke when the link becomes down.
    */
   virtual void SetLinkDownCallback (Callback<void> linkDown) = 0;
-  /* Next functions are not pure virtual so non Qos WifiMacs are not
+  /* Next functions are not pure virtual so non QoS WifiMacs are not
    * forced to implement them.
    */
 
   /**
-   * \param blockAckTimeout the duration for basic block ACK timeout.
+   * \param blockAckTimeout the duration for basic BlockAck timeout.
    *
-   * Sets the timeout for basic block ACK.
+   * Sets the timeout for basic BlockAck.
    */
   virtual void SetBasicBlockAckTimeout (Time blockAckTimeout) = 0;
   /**
-   * \return the current basic block ACK timeout duration.
+   * \return the current basic BlockAck timeout duration.
    */
   virtual Time GetBasicBlockAckTimeout (void) const = 0;
   /**
-   * \param blockAckTimeout
+   * \param blockAckTimeout the duration for compressed BlockAck timeout
    *
-   * Sets the timeout for compressed block ACK.
+   * Sets the timeout for compressed BlockAck.
    */
   virtual void SetCompressedBlockAckTimeout (Time blockAckTimeout) = 0;
   /**
-   * \return the current compressed block ACK timeout duration.
+   * \return the current compressed BlockAck timeout duration.
    */
   virtual Time GetCompressedBlockAckTimeout (void) const = 0;
 
@@ -297,7 +292,7 @@
    * \param standard the wifi standard to be configured
    *
    * This method sets standards-compliant defaults for WifiMac
-   * parameters such as sifs time, slot time, timeout values, etc.,
+   * parameters such as SIFS time, slot time, timeout values, etc.,
    * based on the standard selected.
    *
    * \sa WifiMac::Configure80211a
@@ -330,8 +325,8 @@
 protected:
   /**
    * \param dcf the DCF to be configured
-   * \param cwmin the minimum congestion window for the DCF
-   * \param cwmax the maximum congestion window for the DCF
+   * \param cwmin the minimum contention window for the DCF
+   * \param cwmax the maximum contention window for the DCF
    * \param isDsss flag to indicate whether PHY is DSSS or HR/DSSS
    * \param ac the access category for the DCF
    *
@@ -370,57 +365,57 @@
    * \return the default extended interframe space (EIFS) without
    *         DCF interframe space (DIFS)
    *
-   * Return default SIFS + default CTS-ACK delay
+   * Return default SIFS + default CTS-Ack delay
    */
   static Time GetDefaultEifsNoDifs (void);
   /**
-   * \return the default CTS-ACK delay
+   * \return the default CTS-Ack delay
    *
    * Return a default value for 802.11a at 6Mbps (44 microseconds)
    */
   static Time GetDefaultCtsAckDelay (void);
   /**
-   * \return the default CTS and ACK timeout
+   * \return the default CTS and Ack timeout
    *
-   * Return the default CTS and ACK timeout.
+   * Return the default CTS and Ack timeout.
    * Cts_Timeout and Ack_Timeout are specified in the Annex C
    * (Formal description of MAC operation, see details on the
    * Trsp timer setting at page 346)
    */
   static Time GetDefaultCtsAckTimeout (void);
   /**
-   * Return the default basic block ACK delay.
+   * Return the default basic BlockAck delay.
    * Currently it returns 250 microseconds.
    *
-   * \return the default basic block ACK delay
+   * \return the default basic BlockAck delay
    */
   static Time GetDefaultBasicBlockAckDelay (void);
   /**
-   * Return the default basic block ACK timeout.
+   * Return the default basic BlockAck timeout.
    *
-   * \return the default basic block ACK timeout
+   * \return the default basic BlockAck timeout
    */
   static Time GetDefaultBasicBlockAckTimeout (void);
   /**
-   * Return the default compressed block ACK delay.
+   * Return the default compressed BlockAck delay.
    * Currently it returns 76 microseconds.
    *
-   * \return the default compressed block ACK delay
+   * \return the default compressed BlockAck delay
    */
   static Time GetDefaultCompressedBlockAckDelay (void);
   /**
-   * Return the default compressed block ACK timeout.
+   * Return the default compressed BlockAck timeout.
    *
-   * \return the default compressed block ACK timeout
+   * \return the default compressed BlockAck timeout
    */
   static Time GetDefaultCompressedBlockAckTimeout (void);
 
   /**
-   * \param standard the phy standard to be used
+   * \param standard the PHY standard to be used
    *
    * This method is called by ns3::WifiMac::ConfigureStandard to complete
-   * the configuration process for a requested phy standard. Subclasses should
-   * implement this method to configure their dcf queues according to the
+   * the configuration process for a requested PHY standard. Subclasses should
+   * implement this method to configure their DCF queues according to the
    * requested standard.
    */
   virtual void FinishConfigureStandard (WifiPhyStandard standard) = 0;
@@ -430,55 +425,55 @@
 
   /**
    * This method sets 802.11a standards-compliant defaults for following attributes:
-   * Sifs, Slot, EifsNoDifs, Pifs, CtsTimeout, and AckTimeout.
+   * SIFS, Slot, EifsNoDifs, PIFS, CtsTimeout, and AckTimeout.
    */
   void Configure80211a (void);
   /**
    * This method sets 802.11b standards-compliant defaults for following attributes:
-   * Sifs, Slot, EifsNoDifs, Pifs, CtsTimeout, and AckTimeout.
+   * SIFS, Slot, EifsNoDifs, PIFS, CtsTimeout, and AckTimeout.
    */
   void Configure80211b (void);
   /**
    * This method sets 802.11g standards-compliant defaults for following attributes:
-   * Sifs, Slot, EifsNoDifs, Pifs, CtsTimeout, and AckTimeout.
+   * SIFS, Slot, EifsNoDifs, PIFS, CtsTimeout, and AckTimeout.
    * There is no support for short slot time.
    */
   void Configure80211g (void);
   /**
-   * This method sets 802.11 with 10Mhz channel spacing standards-compliant defaults
-   * for following attributes: Sifs, Slot, EifsNoDifs, Pifs, CtsTimeout, and AckTimeout.
+   * This method sets 802.11 with 10 MHz channel spacing standards-compliant defaults
+   * for following attributes: SIFS, Slot, EifsNoDifs, PIFS, CtsTimeout, and AckTimeout.
    */
   void Configure80211_10Mhz (void);
   /**
-   * This method sets 802.11 with 5Mhz channel spacing standards-compliant defaults
-   * for following attributes: Sifs, Slot, EifsNoDifs, Pifs, CtsTimeout, and AckTimeout.
+   * This method sets 802.11 with 5 MHz channel spacing standards-compliant defaults
+   * for following attributes: SIFS, Slot, EifsNoDifs, PIFS, CtsTimeout, and AckTimeout.
    */
   void Configure80211_5Mhz ();
   /**
    * This method sets 802.11n 2.4 GHz standards-compliant defaults for following attributes:
-   * Sifs, Rifs, Slot, EifsNoDifs, Pifs, CtsTimeout, and AckTimeout.
+   * SIFS, RIFS, Slot, EifsNoDifs, PIFS, CtsTimeout, and AckTimeout.
    * There is no support for short slot time.
    */
   void Configure80211n_2_4Ghz (void);
   /**
    * This method sets 802.11n 5 GHz standards-compliant defaults for following attributes:
-   * Sifs, Rifs, Slot, EifsNoDifs, Pifs, CtsTimeout, and AckTimeout.
+   * SIFS, RIFS, Slot, EifsNoDifs, PIFS, CtsTimeout, and AckTimeout.
    */
   void Configure80211n_5Ghz (void);
   /**
   * This method sets 802.11ac standards-compliant defaults for following attributes:
-  * Sifs, Slot, EifsNoDifs, Pifs, CtsTimeout, and AckTimeout.
+  * SIFS, Slot, EifsNoDifs, PIFS, CtsTimeout, and AckTimeout.
   */
   void Configure80211ac (void);
   /**
    * This method sets 802.11ax 2.4 GHz standards-compliant defaults for following attributes:
-   * Sifs, Slot, EifsNoDifs, Pifs, CtsTimeout, and AckTimeout.
+   * SIFS, Slot, EifsNoDifs, PIFS, CtsTimeout, and AckTimeout.
    * There is no support for short slot time.
    */
   void Configure80211ax_2_4Ghz (void);
   /**
    * This method sets 802.11ax 5 GHz standards-compliant defaults for following attributes:
-   * Sifs, Slot, EifsNoDifs, Pifs, CtsTimeout, and AckTimeout.
+   * SIFS, Slot, EifsNoDifs, PIFS, CtsTimeout, and AckTimeout.
    */
   void Configure80211ax_5Ghz (void);
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/wifi-mac-header.h ns-3.31/src/wifi/model/wifi-mac-header.h
--- ns-3.30.1/src/wifi/model/wifi-mac-header.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/wifi-mac-header.h	2020-06-27 17:38:30.000000000 -0700
@@ -84,7 +84,7 @@
 {
 public:
   /**
-   * ACK policy for QoS frames.
+   * Ack policy for QoS frames.
    */
   enum QosAckPolicy
   {
@@ -230,9 +230,9 @@
    */
   void SetQosNoEosp ();
   /**
-   * Set the QoS ACK policy in the QoS control field.
+   * Set the QoS Ack policy in the QoS control field.
    *
-   * \param policy
+   * \param policy the Qos Ack policy
    */
   void SetQosAckPolicy (QosAckPolicy policy);
   /**
@@ -246,7 +246,7 @@
   /**
    * Set TXOP limit in the QoS control field.
    *
-   * \param txop
+   * \param txop the TXOP limit
    */
   void SetQosTxopLimit (uint8_t txop);
   /**
@@ -307,14 +307,14 @@
   /**
    * Return true if the Type is DATA.  The method does
    * not check the Subtype field. (e.g. the header may be
-   * DATA with QoS)
+   * Data with QoS)
    *
    * \return true if Type is DATA, false otherwise
    */
   bool IsData (void) const;
   /**
    * Return true if the Type is DATA and Subtype is one of the
-   * possible values for QoS DATA.
+   * possible values for QoS Data.
    *
    * \return true if Type is QoS DATA, false otherwise
    */
@@ -345,15 +345,15 @@
    */
   bool IsCfPoll (void) const;
   /**
-   * Return true if the header is a CF-ACK header.
+   * Return true if the header is a CF-Ack header.
    *
-   * \return true if the header is a CF_ACK header, false otherwise
+   * \return true if the header is a CF-Ack header, false otherwise
    */
   bool IsCfAck (void) const;
   /**
-   * Return true if the header is a CF-END header.
+   * Return true if the header is a CF-End header.
    *
-   * \return true if the header is a CF_END header, false otherwise
+   * \return true if the header is a CF-End header, false otherwise
    */
   bool IsCfEnd (void) const;
   /**
@@ -369,21 +369,21 @@
    */
   bool IsCts (void) const;
   /**
-   * Return true if the header is an ACK header.
+   * Return true if the header is an Ack header.
    *
-   * \return true if the header is an ACK header, false otherwise
+   * \return true if the header is an Ack header, false otherwise
    */
   bool IsAck (void) const;
   /**
-   * Return true if the header is a Block ACK Request header.
+   * Return true if the header is a BlockAckRequest header.
    *
-   * \return true if the header is a Block ACK Request header, false otherwise
+   * \return true if the header is a BlockAckRequest header, false otherwise
    */
   bool IsBlockAckReq (void) const;
   /**
-   * Return true if the header is a Block ACK header.
+   * Return true if the header is a BlockAck header.
    *
-   * \return true if the header is a Block ACK header, false otherwise
+   * \return true if the header is a BlockAck header, false otherwise
    */
   bool IsBlockAck (void) const;
   /**
@@ -451,14 +451,14 @@
    *
    * \return true if the header is an Action header, false otherwise
    */
-  bool IsAction () const;
+  bool IsAction (void) const;
   /**
    * Check if the header is a Multihop action header.
    *
    * \return true if the header is a Multihop action header,
    *         false otherwise
    */
-  bool IsMultihopAction () const;
+  bool IsMultihopAction (void) const;
   /**
    * Return the raw duration from the Duration/ID field.
    *
@@ -502,21 +502,21 @@
    */
   bool IsMoreFragments (void) const;
   /**
-   * Return if the QoS ACK policy is Block ACK.
+   * Return if the QoS Ack policy is Block Ack.
    *
-   * \return true if the QoS ACK policy is Block ACK, false otherwise
+   * \return true if the QoS Ack policy is Block Ack, false otherwise
    */
   bool IsQosBlockAck (void) const;
   /**
-   * Return if the QoS ACK policy is No ACK.
+   * Return if the QoS Ack policy is No Ack.
    *
-   * \return true if the QoS ACK policy is No ACK, false otherwise
+   * \return true if the QoS Ack policy is No Ack, false otherwise
    */
   bool IsQosNoAck (void) const;
   /**
-   * Return if the QoS ACK policy is Normal ACK.
+   * Return if the QoS Ack policy is Normal Ack.
    *
-   * \return true if the QoS ACK policy is No ACK, false otherwise
+   * \return true if the QoS Ack policy is No Ack, false otherwise
    */
   bool IsQosAck (void) const;
   /**
@@ -539,9 +539,9 @@
    */
   uint8_t GetQosTid (void) const;
   /**
-   * Return the QoS ACK policy in the QoS control field.
+   * Return the QoS Ack policy in the QoS control field.
    *
-   * \return the QoS ACK policy in the QoS control field
+   * \return the QoS Ack policy in the QoS control field
    */
   QosAckPolicy GetQosAckPolicy (void) const;
   /**
@@ -604,27 +604,27 @@
    */
   void PrintFrameControl (std::ostream &os) const;
 
-  uint8_t m_ctrlType; ///< control type
-  uint8_t m_ctrlSubtype; ///< control subtype
-  uint8_t m_ctrlToDs; ///< control to DS
-  uint8_t m_ctrlFromDs; ///< control from DS
+  uint8_t m_ctrlType;     ///< control type
+  uint8_t m_ctrlSubtype;  ///< control subtype
+  uint8_t m_ctrlToDs;     ///< control to DS
+  uint8_t m_ctrlFromDs;   ///< control from DS
   uint8_t m_ctrlMoreFrag; ///< control more fragments
-  uint8_t m_ctrlRetry; ///< control retry
+  uint8_t m_ctrlRetry;    ///< control retry
   uint8_t m_ctrlMoreData; ///< control more data
-  uint8_t m_ctrlWep; ///< control WEP
-  uint8_t m_ctrlOrder; ///< control order (set to 1 for QoS Data and Management frames to signify that HT/VHT/HE control field is present, knowing that the latter are not implemented yet)
-  uint16_t m_duration; ///< duration
-  Mac48Address m_addr1; ///< address 1
-  Mac48Address m_addr2; ///< address 2
-  Mac48Address m_addr3; ///< address 3
-  uint8_t m_seqFrag; ///< sequence fragment
-  uint16_t m_seqSeq; ///< sequence sequence
-  Mac48Address m_addr4; ///< address 4
-  uint8_t m_qosTid; ///< QOS TID
-  uint8_t m_qosEosp; ///< QOS EOSP
-  uint8_t m_qosAckPolicy; ///< QOS ack policy
-  uint8_t m_amsduPresent; ///< AMSDU present
-  uint8_t m_qosStuff; ///< QOS stuff
+  uint8_t m_ctrlWep;      ///< control WEP
+  uint8_t m_ctrlOrder;    ///< control order (set to 1 for QoS Data and Management frames to signify that HT/VHT/HE control field is present, knowing that the latter are not implemented yet)
+  uint16_t m_duration;    ///< duration
+  Mac48Address m_addr1;   ///< address 1
+  Mac48Address m_addr2;   ///< address 2
+  Mac48Address m_addr3;   ///< address 3
+  uint8_t m_seqFrag;      ///< sequence fragment
+  uint16_t m_seqSeq;      ///< sequence sequence
+  Mac48Address m_addr4;   ///< address 4
+  uint8_t m_qosTid;       ///< QoS TID
+  uint8_t m_qosEosp;      ///< QoS EOSP
+  uint8_t m_qosAckPolicy; ///< QoS Ack policy
+  uint8_t m_amsduPresent; ///< A-MSDU present
+  uint8_t m_qosStuff;     ///< QoS stuff
 };
 
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/wifi-mac-queue.cc ns-3.31/src/wifi/model/wifi-mac-queue.cc
--- ns-3.30.1/src/wifi/model/wifi-mac-queue.cc	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wifi/model/wifi-mac-queue.cc	2020-06-27 17:38:30.000000000 -0700
@@ -39,10 +39,11 @@
     .SetParent<Queue<WifiMacQueueItem> > ()
     .SetGroupName ("Wifi")
     .AddConstructor<WifiMacQueue> ()
-    .AddAttribute ("MaxQueueSize",
+    .AddAttribute ("MaxSize",
                    "The max queue size",
                    QueueSizeValue (QueueSize ("500p")),
-                   MakeQueueSizeAccessor (&WifiMacQueue::SetMaxQueueSize),
+                   MakeQueueSizeAccessor (&QueueBase::SetMaxSize,
+                                          &QueueBase::GetMaxSize),
                    MakeQueueSizeChecker ())
     .AddAttribute ("MaxDelay", "If a packet stays longer than this delay in the queue, it is dropped.",
                    TimeValue (MilliSeconds (500)),
@@ -71,20 +72,9 @@
   NS_LOG_FUNCTION_NOARGS ();
 }
 
-const WifiMacQueue::ConstIterator WifiMacQueue::EMPTY = std::list<Ptr<WifiMacQueueItem>> ().end ();
+static std::list<Ptr<WifiMacQueueItem>> g_emptyWifiMacQueue;
 
-void
-WifiMacQueue::SetMaxQueueSize (QueueSize size)
-{
-  NS_LOG_FUNCTION (this << size);
-  m_maxSize = size;
-}
-
-QueueSize
-WifiMacQueue::GetMaxQueueSize (void) const
-{
-  return m_maxSize;
-}
+const WifiMacQueue::ConstIterator WifiMacQueue::EMPTY = g_emptyWifiMacQueue.end ();
 
 void
 WifiMacQueue::SetMaxDelay (Time delay)
@@ -139,8 +129,6 @@
   NS_ASSERT_MSG (GetMaxSize ().GetUnit () == QueueSizeUnit::PACKETS,
                  "WifiMacQueues must be in packet mode");
 
-  QueueBase::SetMaxSize (GetMaxQueueSize ()); //Make sure QueueBase has the same maximum queue size
-
   // insert the item if the queue is not full
   if (QueueBase::GetNPackets () < GetMaxSize ().GetValue ())
     {
